.586
.MODEL FLAT, STDCALL
OPTION CASEMAP:NONE
;--------------------------------------------------------------------------------
INCLUDE windows.inc
INCLUDE kernel32.inc
INCLUDE	user32.inc
INCLUDELIB kernel32.lib
INCLUDELIB user32.lib
;--------------------------------------------------------------------------------
CreatePanels			PROTO
MessageLoop				PROTO
WinMain					PROTO	:HINSTANCE,:HINSTANCE,:LPSTR,:DWORD
;--------------------------------------------------------------------------------
.DATA?
	hInstance		DWORD		? ;our module instance handle
	hWnd_Main		DWORD		? ;handle of the main window
;--------------------------------------------------------------------------------
.DATA
	ExitCode		DWORD		-1 ;code returned by the message loop
	;set it to -1 = returned value when an error occurs before message loop,
	hHeapApp		DWORD		0
;--------------------------------------------------------------------------------
.CONST
	ClassName_MainWindow	BYTE	"MWClsName",0
	AppName					BYTE	"Simple Template",0
;--------------------------------------------------------------------------------
.CODE
App_Entry_Point:
	INVOKE	GetModuleHandle,	NULL
	mov		hInstance,			eax
	
	INVOKE	CreatePanels		;create any window that you need
	test	eax,				eax
	jz		App_Ready_To_Die
	
	;some other things you need to be ready before entering the message loop
	;Example:
	;INVOKE HeapCreate, NULL, 500h, 0
	;test   eax, eax
	;jz     App_Ready_To_Die
	;mov		hHeapApp,		eax
	
	INVOKE	MessageLoop
	mov		ExitCode,			eax
	
App_Ready_To_Die:
	;free any resources here
	;Example
	;.IF		hHeapApp!=0
	;	INVOKE	HeapDestroy,		hHeapApp
	;.ENDIF
	
INVOKE	ExitProcess,			ExitCode
;--------------------------------------------------------------------------------
CreatePanels		PROC
LOCAL	WNDC:WNDCLASSEX
	
    mov		eax,				hInstance
    mov   	WNDC.cbSize,		SIZEOF WNDCLASSEX 
    mov   	WNDC.style, 		CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW or CS_DBLCLKS
    mov   	WNDC.lpfnWndProc,	OFFSET WndProc 
    mov   	WNDC.cbClsExtra,	NULL 
    mov   	WNDC.cbWndExtra,	NULL 
    mov   	WNDC.hInstance,		eax 
    mov   	WNDC.hbrBackground,	COLOR_BACKGROUND+1 
    mov   	WNDC.lpszMenuName,	NULL 
    mov   	WNDC.lpszClassName,	OFFSET ClassName_MainWindow
    INVOKE 	LoadIcon,			NULL,IDI_EXCLAMATION 
    mov   	WNDC.hIcon,			eax 
    mov   	WNDC.hIconSm,		eax 
    INVOKE	LoadCursor,			0,IDC_ARROW
    mov   	WNDC.hCursor,		eax
    ;and go register
    INVOKE 	RegisterClassEx,	ADDR WNDC
	test	eax,			eax
	jz		Get_Out
	
	;main window
    INVOKE 	CreateWindowEx,		WS_EX_WINDOWEDGE,\
    							ADDR ClassName_MainWindow,ADDR AppName,\ 
                				WS_VISIBLE or WS_OVERLAPPEDWINDOW,\ 
	 						    CW_USEDEFAULT,\
	 						    CW_USEDEFAULT,\
	 						    600,\
	 						    400,\
	 						    NULL,NULL,hInstance,NULL 
    mov    	hWnd_Main,			eax
	or		eax,				eax
	jz		Get_Out
	
	
mov	eax,	1
Get_Out:
ret
CreatePanels 		ENDP
;--------------------------------------------------------------------------------
MessageLoop			PROC
LOCAL	msg:MSG

	.WHILE TRUE
		INVOKE GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		INVOKE TranslateMessage, ADDR msg
		INVOKE DispatchMessage,  ADDR msg
	.ENDW
mov     eax,msg.wParam
ret
MessageLoop 		ENDP
;--------------------------------------------------------------------------------
WndProc	 					PROC	 hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	;			WM_DESTROY
	cmp		uMsg,			WM_DESTROY
	jne		MW_WM_DESTROY__END
		INVOKE	PostQuitMessage, 	NULL
		jmp		MSG_Processed_YES
	MW_WM_DESTROY__END:
	;			WM_CLOSE
		cmp		uMsg,			WM_CLOSE
		jne		MW_WM_CLOSE__END
			INVOKE	DestroyWindow,	hWnd_Main
			jmp		MSG_Processed_YES
	MW_WM_CLOSE__END:
	;			Some other message
	
	
	
	
MSG_Processed_NOT:
INVOKE 	DefWindowProc,		hWnd,uMsg,wParam,lParam     
ret
MSG_Processed_YES:
xor eax,eax
ret
WndProc				ENDP
;--------------------------------------------------------------------------------
END App_Entry_Point